(function() {
	'use strict';

	angular
		.module('barebone.bus')
		.controller('BusController', BusController);

	BusController.$inject = [
		'AppDB',
		'busService',
		'$timeout',
		'$state',
		'motion',
		'$rootScope',
		'$scope',
		'$ionicPopup',
		'$interval',
		'ionicDatePicker',
		'LANG',
		'destinations'
	];

	/* @ngInject */
	function BusController(
		AppDB, busService, $timeout,$state,motion,$rootScope,$scope,$ionicPopup,$interval,ionicDatePicker,LANG,destinations) {


		if($rootScope.stopTimeInt){
			$interval.cancel($rootScope.stopTimeInt);
		}

		var traveldate = new Date();
		var selecteddate = new Date();
        var month = traveldate.getMonth() + 1;
        $rootScope.searchResult = '';
		var vm = angular.extend(this, {
			from         : '',
			to 			 : '',
			adult 		 : 1,
			promo_code 	 : '',
			type 		 : '',
		passenger_type   : '',
		passenger_types  : [
							{'id':'male','name': $rootScope.appLang.male },
							{'id':'female','name': $rootScope.appLang.female },
							{'id':'monk','name': $rootScope.appLang.monk },
							{'id':'group','name': $rootScope.appLang.group }
							],
		 		  types  : [
							{'id':'foreigner','name': $rootScope.appLang.foreigner },
							{'id':'local','name': $rootScope.appLang.local }
							],
			traveldate   : traveldate.getDate()+'-'+ month +'-'+ traveldate.getFullYear(),
			selecteddate   : selecteddate,
			destinations : destinations,
			buses        : [],
			searchBusroutes : searchBusroutes,
			openDatePicker : openDatePicker,
			doRefresh : doRefresh
		});

		(function activate() {
			
			motion.expandHeader();
			motion.ink();

		})();

		function openDatePicker(date_value){
			var ipObj1 = {
			        callback: function (val) {  //Mandatory
			          		vm.selecteddate = new Date(val);
			          		  if (typeof(val) === 'undefined') {
					  } else {
				        		var month = vm.selecteddate.getMonth() + 1;
								vm.traveldate = vm.selecteddate.getDate()+'-'+ month +'-'+vm.selecteddate.getFullYear();
					 }
			        },
			        inputDate: vm.selecteddate,
			        mondayFirst: true,
			        from: new Date(),	//Optional
			        closeOnSelect: true,
			        templateType: 'popup'
			      };
			      ionicDatePicker.openDatePicker(ipObj1);
		}

		function searchBusroutes()
		{
			
			if(vm.from.name == vm.to.name || !vm.from || !vm.to || !vm.adult || !vm.traveldate || !vm.type || !vm.passenger_type)
			{
				$ionicPopup.alert({
							    title: $rootScope.appLang.invalid,
							    template: $rootScope.appLang.plz_fill_up
							  });
				return false;
			}
			var searchResult = {
								from_destination: vm.from.name,
								to_destination: vm.to.name,
								from_name: vm.from.name,
								to_name: vm.to.name,
								adult: vm.adult,
								promo_code: vm.promo_code,
								type: vm.type.id,
								passenger_type: vm.passenger_type.id,
								traveldate: vm.traveldate

								// from_destination: vm.from,
								// to_destination: vm.to,
								// adult: vm.adult,
								// traveldate: vm.traveldate,
								// type: vm.type,
								// passenger_type: vm.passenger_type
     		    			};
     		    		
     		$rootScope.searchResult = searchResult;

			$state.go('app.buslist');
		}

		function doRefresh() {
			busService.getDestination()
			.then(function(data) {
				vm.destinations = data;
				$scope.$broadcast('scroll.refreshComplete');
			});
		}


	}
})();