(function() {
	'use strict';

	angular
		.module('barebone.myprofile')
		.controller('MyprofileController', MyprofileController);

	MyprofileController.$inject = [
		'$scope',
		'homeDataService',
		'$rootScope',
		'$timeout',
		'$state',
		'$auth',
		'$ionicPopup',
		'motion'
	];

	/* @ngInject */
	function MyprofileController($scope, homeDataService, $rootScope,$timeout,$state,$auth,$ionicPopup,motion) {

		var vm = angular.extend(this, {
			userprofile  : $rootScope.userInfo,
			doUpdate : doUpdate
		});

		(function activate() {
			motion.expandHeader();
		})();

		function doUpdate() {

				if(vm.userprofile.new_password === vm.userprofile.confirm_password){ 

					if(vm.userprofile.new_password){

						var credentials = {
									name		: 	  vm.userprofile.name,
									organization:     vm.userprofile.organization,
									mobile		: 	  vm.userprofile.mobile,
									address		: 	  vm.userprofile.address,
									password 	: 	  vm.userprofile.new_password
								}

					}else{

						var credentials = {
									name		: 	  vm.userprofile.name,
									organization:     vm.userprofile.organization,
									mobile		: 	  vm.userprofile.mobile,
									address		: 	  vm.userprofile.address
								}

					}

					return homeDataService.updateprofile(credentials).then(function(data){
						
						var msg = data.message;

						if(vm.userprofile.new_password && msg){

							vm.userprofile.new_password = '';
							vm.userprofile.confirm_password = '';

							$auth.logout();
							$ionicPopup.alert({
					            title: 'Success',
					            content: 'Successfully saved your profile and new password.<br>Please login again with new password!'
					          });
							$rootScope.$broadcast('load:Islogin');

						}else{

							vm.userprofile.new_password = '';
							vm.userprofile.confirm_password = '';
							$ionicPopup.alert({
					            title: 'Success',
					            content: msg || 'Can\'t establish internet connection.'
					          });
						}

					});

				}else{

					vm.userprofile.new_password = '';
					vm.userprofile.confirm_password = '';
					$ionicPopup.alert({
				            title: 'Warning',
				            content: 'Sorry,your change password don\'t match with confirm password'
				          });
				}
		}

	}
})();